#include "unrarlib.h"
#include <windows.h>
#include <stdio.h>
#include <direct.h>
#include <firari.h> //explode() implode() AddToArray() defined
#include <lvp\string.h> //String defined
#include <lvp\vector.h> //vector<> defined

extern "C" int WINAPI ListAll(HWND,HWND,char *data,char,BOOL,BOOL)
{

	Array A;
	ArchiveList_struct *List = NULL;
	urarlib_list(data,(ArchiveList_struct*)&List);
	int crc = 0;
	while (List != NULL)
	{
		String name(List->item.Name);
		List = (ArchiveList_struct*)List->next;
		AddToArray(A,name);
	}
	String list = implode(A,"\t");
	strcpy(data,list.c_str());
	urarlib_freelist(List);
	return 3;
}

extern "C" int WINAPI ListFiles(HWND,HWND,char *data,char,BOOL,BOOL)
{
	Array A;
	ArchiveList_struct *List = NULL;
	urarlib_list(data,(ArchiveList_struct*)&List);
	while (List != NULL)
	{
		String name(List->item.Name);
		if (List->item.FileAttr == 32)
			AddToArray(A,name);
		List = (ArchiveList_struct*)List->next;
	}
	String list = implode(A,"\t");
	strcpy(data,list.c_str());
	urarlib_freelist(List);
	return 3;
}

extern "C" int WINAPI ListFolders(HWND,HWND,char *data,char,BOOL,BOOL)
{
	Array A;
	ArchiveList_struct *List = NULL;
	urarlib_list(data,(ArchiveList_struct*)&List);
	while (List != NULL)
	{
		String name(List->item.Name);
		if (List->item.FileAttr == 16)
			AddToArray(A,name);
		List = (ArchiveList_struct*)List->next;
	}
	String list = implode(A,"\t");
	strcpy(data,list.c_str());
	urarlib_freelist(List);
	return 3;
}

extern "C" int WINAPI FileInfo(HWND,HWND,char *data,char,BOOL,BOOL)
{
	String parms(data);
	Array parmsarray = explode(parms,":");
	ArchiveList_struct *List = NULL;
	urarlib_list(parmsarray[0].c_str(),(ArchiveList_struct*)&List);
	bool found = false;
	while (List != NULL)
	{
		String name(List->item.Name);
		if (name == parmsarray[1])
		{
			wsprintf(data,"S_OK %d %d %d %x %x %d %d",List->item.UnpSize,List->item.PackSize,List->item.HostOS,List->item.FileTime,List->item.FileCRC,List->item.UnpVer,List->item.Method);
			found = true;
			break;
		}
	List = (ArchiveList_struct*)List->next;
	}
	if (!found)
		strcpy(data,"S_ERR");
	urarlib_freelist(List);
	return 3;
}

extern "C" int WINAPI UnRAR(HWND,HWND,char *data,char,BOOL,BOOL)
{
	int ex_ok = 0;
	int ex_err = 0;
	int ex_dir = 0;
	String parms(data);
	Array parmsarray = explode(parms," ");
	String archive = parmsarray[0];
	String ext_dir = parmsarray[1];
	String pass;
	bool pass_defined = (parmsarray.length() == 3);
	if (pass_defined)
		pass = parmsarray[2];
	mkdir(ext_dir.c_str());
	ArchiveList_struct *List = NULL;
	urarlib_list(archive.c_str(),(ArchiveList_struct*)&List);
	while (List != NULL)
	{
		if (List->item.FileAttr == 16)
		{
			String name(List->item.Name);
			String dir = ext_dir + "\\" + name;
			mkdir(dir.c_str());
			ex_dir++;
		}
		else
		{
			String name(List->item.Name);
			name = ext_dir + "\\" + name;
			char *data_ptr;
			unsigned long datasize;
			bool get;
			if (pass_defined)
				get = urarlib_get(&data_ptr,&datasize,List->item.Name,parmsarray[0].c_str(),pass.c_str());
			else
				get = urarlib_get(&data_ptr,&datasize,List->item.Name,parmsarray[0].c_str(),NULL);
			if(get)
			{
				FILE *datafp;
				datafp = fopen(name.c_str(),"wb");
				fwrite(data_ptr, 1, datasize, datafp);
				fclose(datafp);
				ex_ok++;
			}
			else
				ex_err++;
		}
		List = (ArchiveList_struct*)List->next;
	}
	wsprintf(data,"S_OK %d %d %d",ex_dir,ex_ok,ex_err);
	//wsprintf(data,"Arsiv: %s, Hedef: %s, Sifre: %s",archive.c_str(),ext_dir.c_str(),pass.c_str());
	urarlib_freelist(List);
	return 3;
}

extern "C" int WINAPI UnRARFile(HWND,HWND,char *data,char,BOOL,BOOL)
{
	int ex_ok = 0;
	int ex_err = 0;
	int ex_dir = 0;
	String parms(data);
	Array parmsarray = explode(parms," ");
	String archive = parmsarray[0];
	String file = parmsarray[1];
	String ext_dir = parmsarray[2];
	String pass;
	bool pass_defined = (parmsarray.length() == 4);
	if (pass_defined)
		pass = parmsarray[3];
	mkdir(ext_dir.c_str());
	ArchiveList_struct *List = NULL;
	urarlib_list(archive.c_str(),(ArchiveList_struct*)&List);
	while (List != NULL)
	{
		if (List->item.FileAttr == 16)
		{
			String name(List->item.Name);
			if (file.find(name) == 0)
			{
				String dir = ext_dir + "\\" + name;
				mkdir(dir.c_str());
				ex_dir++;
			}
		}
		else
		{
			String name(List->item.Name);
			if (name == file)
			{
				name = ext_dir + "\\" + name;
				char *data_ptr;
				unsigned long datasize;
				bool get;
				if (pass_defined)
					get = urarlib_get(&data_ptr,&datasize,List->item.Name,parmsarray[0].c_str(),pass.c_str());
				else
					get = urarlib_get(&data_ptr,&datasize,List->item.Name,parmsarray[0].c_str(),NULL);
				if(get)
				{
					FILE *datafp;
					datafp = fopen(name.c_str(),"wb");
					fwrite(data_ptr, 1, datasize, datafp);
					fclose(datafp);
					ex_ok++;
				}
				else
					ex_err++;
			}
		}
		List = (ArchiveList_struct*)List->next;
	}
	wsprintf(data,"S_OK %d %d %d",ex_dir,ex_ok,ex_err); 
	urarlib_freelist(List);
	return 3;
}


extern "C" int WINAPI DLLInfo(HWND,HWND,char *data,char,BOOL,BOOL)
{
	strcpy(data,"UnRAR DLL 1.0 by Firari email:serkan_kaba@yahoo.com ICQ:68427074");
	return 3;
}
